|
| 3d_asm.S
|
| August 31, 1999
|
| Written and copyright 1999 by Till Harbaum
| Distributed under the GNU General Public License; see the README file.
| This code comes with NO WARRANTY.
|

.globl draw_hline_int, draw_hline_array, screen_base, hline_mask, hline_shade
	
	.data	
hline_mask:
        .long 0xffffffff, 0x3fffffff, 0x0fffffff, 0x03ffffff
	.long 0x00ffffff, 0x003fffff, 0x000fffff, 0x0003ffff
	.long 0x0000ffff, 0x00003fff, 0x00000fff, 0x000003ff
	.long 0x000000ff, 0x0000003f, 0x0000000f, 0x00000003

	.long 0xc0000000, 0xf0000000, 0xfc000000, 0xff000000 
	.long 0xffc00000, 0xfff00000, 0xfffc0000, 0xffff0000 
	.long 0xffffc000, 0xfffff000, 0xfffffc00, 0xffffff00
	.long 0xffffffc0, 0xfffffff0, 0xfffffffc, 0xffffffff

|hline_shade:
|	.long 0x00000000, 0x11111111, 0x55555555, 0x66666666
|	.long 0xaaaaaaaa, 0xbbbbbbbb, 0xffffffff, 0xffffffff

|	.long 0x00000000, 0x44444444, 0x55555555, 0x99999999
|	.long 0xaaaaaaaa, 0xeeeeeeee, 0xffffffff, 0xffffffff

	.text

draw_hline_int:
	movm.l	%d3-%d6,-(%sp)		| 4 Reg

        move.w	20(%sp),%d0		| Y coordinate	

        move.w	%d0,%d5			| check it
	cmp.w	#99,%d5			| 0..99
	bhi	quit
	
	moveq	#0,%d5
	move.w	%d0,%d5			| Y = 40*Y = 8*((4*y+y))
	lsl.w	#2,%d5			| * 4
	add.w	%d0,%d5			| + Y
	lsl.w	#3,%d5			| * 8
	move.l	screen_base(%a4),%a0	| get screen base address
	add.l	%d5,%a0			| + Y
	add.l	#24*40,%a0
		
|        move.w	26(%sp),%d4		| get color
|	btst	#0,%d0			| Y-Koo
|	bne.s	leven
|	addq.w	#8,%d4			| offset to second table
|leven:	
|	lea	hline_shade(%a4),%a1	| color table
|	lsl.w	#2,%d4			| long word offset
|	move.l	(%a1,%d4.w),%d4		| get color pattern 

	move.l	26(%sp),%d4	
	move.l	%d4,%d5
		
        move.w	22(%sp),%d0		| X start
        move.w	24(%sp),%d1		| X end
	
	cmp.w	%d1,%d0
	bgt.s	quit    		| dont draw backwards

|  ble.s	no_swap
|  exg	%d0,%d1
|no_swap:	
	
	cmp.w	#159,%d0		| start to far right
	bgt.s	quit
	
	tst.w	%d0			| x range check 0
	bpl.s	noneg
	clr.w	%d0
noneg:

	tst.w	%d1			| end too far left
	bmi.s	quit
	
	cmp.w	#159,%d1
	bls.s	no2big
	move.w	#159,%d1
no2big:	
			
	move.w	%d0,%d2
	lea	hline_mask(%a4),%a1
	and.w	#0xf,%d2
	lsl.w	#2,%d2
	move.l	(%a1,%d2.w),%d2		| start mask

	move.w	%d1,%d3
	and.w	#0xf,%d3
	lsl.w	#2,%d3
	move.l	64(%a1,%d3.w),%d3	| end mask

	lsr.w	#4,%d0
	lsr.w	#4,%d1

	move.w	%d0,%d6
	lsl.w	#2,%d6
	add.w	%d6,%a0			| add start offset

	sub.w	%d0,%d1
	tst.w	%d1
	beq.s	single_draw

	and.l	%d2,%d4
	not.l	%d2
	and.l	%d2,(%a0)
	or.l	%d4,(%a0)+

	subq	#2,%d1
	bmi.s	no_loop

loop:	
	move.l	%d5,(%a0)+
	dbra	%d1,loop

no_loop:
	and.l	%d3,%d5
	not.l	%d3
	and.l	%d3,(%a0)
	or.l	%d5,(%a0)+
				
quit:		
        movm.l	(%sp)+,%d3-%d6
        rts
	
single_draw:
	and.l	%d2,%d3
	and.l	%d3,%d4
	not.l	%d3
	and.l	%d3,(%a0)
	or.l	%d4,(%a0)

        movm.l	(%sp)+,%d3-%d6
        rts


draw_hline_array:
	movm.l	%d3-%d7/%a2-%a3,-(%sp)	| 7 Reg

        move.w	36(%sp),%d0		| Y start coordinate	

	|| range check y start coordinate
	cmp.w	#99,%d0			| > 99 -> exit
	bgt	aquit

	cmp.w	#0,%d0			| < 0 -> =0 
	bge.s	no_loy0
	clr.w	%d0
no_loy0:	

        move.w	38(%sp),%d5		| Y end coordinate	

	|| range check y end coordinate
	cmp.w	#99,%d5			| > 99  -> 99
	ble.s	no_loy1
	move.w	#99,%d5
no_loy1:	

	sub.w	%d0,%d5			| diff y-end - y-start
	sub.w	#1,%d5
	bmi	aquit
			
	|| calculate address for first line
	moveq	#0,%d4
	move.w	%d0,%d4			| Y = 40*Y = 8*((4*y+y))
	lsl.l	#2,%d4			| * 4
	add.l	%d0,%d4			| + Y
	lsl.l	#3,%d4			| * 8
	
	move.l	screen_base(%a4),%a0	| get screen base address	
	add.l	%d4,%a0			| + Y
	add.l	#24*40,%a0		| fix start offset

	move.l	%a0,%a2			| save address for later ...
			
	move.l	32(%sp),%a3		| get x table address
	lsl	#2,%d0
	and.l	#0xffff,%d0
	add.l	%d0,%a3
	
        move.w	40(%sp),%d4		| get color
	lsl.w	#2,%d4			| long word offset
	lea	hline_shade(%a4),%a1	| color table
	move.l	(%a1,%d4.w),%d6		| get color pattern 1 
	move.l	32(%a1,%d4.w),%d7	| get color pattern 2 

	btst	#2,%d0			| formerly lowest y bit
	bne.s	nix_swap
	exg	%d6,%d7			| not doing this give some
nix_swap:				| kind of moire on the lcd
	
	lea	hline_mask(%a4),%a1

	|| this is the main drawing loop
main_loop:	
	move.w	(%a3)+,%d0		| X start
	move.w	(%a3)+,%d1		| X end
				
	cmp.w	%d1,%d0
	bgt.s	aquit    		| dont draw backwards (stop whole polygon)

	cmp.w	#159,%d0		| start to far right
	bgt.s	askip			| skip to next line
	
	tst.w	%d0			| x range check 0
	bpl.s	anoneg
	clr.w	%d0
anoneg:

	tst.w	%d1			| end too far left
	bmi.s	askip
	
	cmp.w	#159,%d1
	bls.s	ano2big
	move.w	#159,%d1
ano2big:	
			
	move.w	%d0,%d2
	and.w	#0xf,%d2
	lsl.w	#2,%d2
	move.l	(%a1,%d2.w),%d2		| start mask

	move.w	%d1,%d3
	and.w	#0xf,%d3
	lsl.w	#2,%d3
	move.l	64(%a1,%d3.w),%d3	| end mask

	lsr.w	#4,%d0
	lsr.w	#4,%d1

	move.w	%d0,%d4
	lsl.w	#2,%d4
	add.w	%d4,%a0			| add horizontal offset
	
	sub.w	%d0,%d1
	tst.w	%d1
	beq.s	asingle_draw

	move.l	%d6,%d4			| get color
	and.l	%d2,%d4
	not.l	%d2
	and.l	%d2,(%a0)
	or.l	%d4,(%a0)+

	subq	#2,%d1
	bmi.s	ano_loop

aloop:	
	move.l	%d6,(%a0)+
	dbra	%d1,aloop

ano_loop:
	move.l	%d6,%d4
	and.l	%d3,%d4
	not.l	%d3
	and.l	%d3,(%a0)
	or.l	%d4,(%a0)+

askip:	
	exg	%d6,%d7			| exchange colors
	add.l	#40,%a2			| skip to net line
	move.l	%a2,%a0			| adress of next line
	dbra	%d5,main_loop	
			
aquit:		
        movm.l	(%sp)+,%d3-%d7/%a2-%a3
        rts
	
asingle_draw:
	move.l	%d6,%d4
	and.l	%d2,%d3
	and.l	%d3,%d4
	not.l	%d3
	and.l	%d3,(%a0)
	or.l	%d4,(%a0)

	bra.s	askip



